diff -ruN vdr-1.7.0/remux.c vdr-1.7.1/remux.c
--- vdr-1.7.0/remux.c	2007-11-25 14:56:03.000000000 +0100
+++ vdr-1.7.1/remux.c	2008-08-15 16:49:34.000000000 +0200
@@ -11,15 +11,24 @@
  * The cRepacker family's code was originally written by Reinhard Nissl <rnissl@gmx.de>,
  * and adapted to the VDR coding style by Klaus.Schmidinger@cadsoft.de.
  *
- * $Id: remux.c 2.0 2007/11/25 13:56:03 kls Exp $
+ * $Id: remux.c 2.1 2008/08/15 14:49:34 kls Exp $
  */
 
 #include "remux.h"
 #include <stdlib.h>
 #include "channels.h"
+#include "device.h"
+#include "libsi/si.h"
+#include "libsi/section.h"
+#include "libsi/descriptor.h"
 #include "shutdown.h"
 #include "tools.h"
 
+// Set this to 'true' for debug output:
+static bool DebugPatPmt = false;
+
+#define dbgpatpmt(a...) if (DebugPatPmt) fprintf(stderr, a)
+
 ePesHeader AnalyzePesHeader(const uchar *Data, int Count, int &PesPayloadOffset, bool *ContinuationHeader)
 {
   if (Count < 7)
@@ -1413,7 +1422,6 @@
 //pts_dts flags
 #define PTS_ONLY         0x80
 
-#define TS_SIZE        188
 #define PID_MASK_HI    0x1F
 #define CONT_CNT_MASK  0x0F
 
@@ -2007,8 +2015,6 @@
   return -1;
 }
 
-#define TS_SYNC_BYTE 0x47
-
 int cRemux::Put(const uchar *Data, int Count)
 {
   int used = 0;
@@ -2182,3 +2188,466 @@
   else
      dsyslog("SetBrokenLink: no video packet in frame");
 }
+
+// --- cPatPmtGenerator ------------------------------------------------------
+
+cPatPmtGenerator::cPatPmtGenerator(void)
+{
+  numPmtPackets = 0;
+  patCounter = pmtCounter = 0;
+  patVersion = pmtVersion = 0;
+  esInfoLength = NULL;
+  GeneratePat();
+}
+
+void cPatPmtGenerator::IncCounter(int &Counter, uchar *TsPacket)
+{
+  TsPacket[3] = (TsPacket[3] & 0xF0) | Counter;
+  if (++Counter > 0x0F)
+     Counter = 0x00;
+}
+
+void cPatPmtGenerator::IncVersion(int &Version)
+{
+  if (++Version > 0x1F)
+     Version = 0x00;
+}
+
+void cPatPmtGenerator::IncEsInfoLength(int Length)
+{
+  if (esInfoLength) {
+     Length += ((*esInfoLength & 0x0F) << 8) | *(esInfoLength + 1);
+     *esInfoLength = 0xF0 | (Length >> 8);
+     *(esInfoLength + 1) = Length;
+     }
+}
+
+int cPatPmtGenerator::MakeStream(uchar *Target, uchar Type, int Pid)
+{
+  int i = 0;
+  Target[i++] = Type; // stream type
+  Target[i++] = 0xE0 | (Pid >> 8); // dummy (3), pid hi (5)
+  Target[i++] = Pid; // pid lo
+  esInfoLength = &Target[i];
+  Target[i++] = 0xF0; // dummy (4), ES info length hi
+  Target[i++] = 0x00; // ES info length lo
+  return i;
+}
+
+int cPatPmtGenerator::MakeAC3Descriptor(uchar *Target)
+{
+  int i = 0;
+  Target[i++] = SI::AC3DescriptorTag;
+  Target[i++] = 0x01; // length
+  Target[i++] = 0x00;
+  IncEsInfoLength(i);
+  return i;
+}
+
+int cPatPmtGenerator::MakeSubtitlingDescriptor(uchar *Target, const char *Language)
+{
+  int i = 0;
+  Target[i++] = SI::SubtitlingDescriptorTag;
+  Target[i++] = 0x08; // length
+  Target[i++] = *Language++;
+  Target[i++] = *Language++;
+  Target[i++] = *Language++;
+  Target[i++] = 0x00; // subtitling type
+  Target[i++] = 0x00; // composition page id hi
+  Target[i++] = 0x01; // composition page id lo
+  Target[i++] = 0x00; // ancillary page id hi
+  Target[i++] = 0x01; // ancillary page id lo
+  IncEsInfoLength(i);
+  return i;
+}
+
+int cPatPmtGenerator::MakeLanguageDescriptor(uchar *Target, const char *Language)
+{
+  int i = 0;
+  Target[i++] = SI::ISO639LanguageDescriptorTag;
+  Target[i++] = 0x04; // length
+  Target[i++] = *Language++;
+  Target[i++] = *Language++;
+  Target[i++] = *Language++;
+  Target[i++] = 0x01; // audio type
+  IncEsInfoLength(i);
+  return i;
+}
+
+int cPatPmtGenerator::MakeCRC(uchar *Target, const uchar *Data, int Length)
+{
+  int crc = SI::CRC32::crc32((const char *)Data, Length, 0xFFFFFFFF);
+  int i = 0;
+  Target[i++] = crc >> 24;
+  Target[i++] = crc >> 16;
+  Target[i++] = crc >> 8;
+  Target[i++] = crc;
+  return i;
+}
+
+#define P_TSID    0x8008 // pseudo TS ID
+#define P_PNR     0x0084 // pseudo Program Number
+#define P_PMT_PID 0x0084 // pseudo PMT pid
+
+void cPatPmtGenerator::GeneratePat(void)
+{
+  memset(pat, 0xFF, sizeof(pat));
+  uchar *p = pat;
+  int i = 0;
+  p[i++] = 0x47; // TS indicator
+  p[i++] = 0x40; // flags (3), pid hi (5)
+  p[i++] = 0x00; // pid lo
+  p[i++] = 0x10; // flags (4), continuity counter (4)
+  int PayloadStart = i;
+  p[i++] = 0x00; // table id
+  p[i++] = 0xB0; // section syntax indicator (1), dummy (3), section length hi (4)
+  int SectionLength = i;
+  p[i++] = 0x00; // section length lo (filled in later)
+  p[i++] = P_TSID >> 8;   // TS id hi
+  p[i++] = P_TSID & 0xFF; // TS id lo
+  p[i++] = 0xC1 | (patVersion << 1); // dummy (2), version number (5), current/next indicator (1)
+  p[i++] = 0x00; // section number
+  p[i++] = 0x00; // last section number
+  p[i++] = P_PNR >> 8;   // program number hi
+  p[i++] = P_PNR & 0xFF; // program number lo
+  p[i++] = 0xE0 | (P_PMT_PID >> 8); // dummy (3), PMT pid hi (5)
+  p[i++] = P_PMT_PID & 0xFF; // PMT pid lo
+  pat[SectionLength] = i - SectionLength - 1 + 4; // -2 = SectionLength storage, +4 = length of CRC
+  MakeCRC(pat + i, pat + PayloadStart, i - PayloadStart);
+  IncVersion(patVersion);
+}
+
+void cPatPmtGenerator::GeneratePmt(tChannelID ChannelID)
+{
+  // generate the complete PMT section:
+  uchar buf[MAX_SECTION_SIZE];
+  memset(buf, 0xFF, sizeof(buf));
+  numPmtPackets = 0;
+  cChannel *Channel = Channels.GetByChannelID(ChannelID);
+  if (Channel) {
+     int Vpid = Channel->Vpid();
+     uchar *p = buf;
+     int i = 0;
+     p[i++] = 0x02; // table id
+     int SectionLength = i;
+     p[i++] = 0xB0; // section syntax indicator (1), dummy (3), section length hi (4)
+     p[i++] = 0x00; // section length lo (filled in later)
+     p[i++] = P_PNR >> 8;   // program number hi
+     p[i++] = P_PNR & 0xFF; // program number lo
+     p[i++] = 0xC1 | (pmtVersion << 1); // dummy (2), version number (5), current/next indicator (1)
+     p[i++] = 0x00; // section number
+     p[i++] = 0x00; // last section number
+     p[i++] = 0xE0 | (Vpid >> 8); // dummy (3), PCR pid hi (5)
+     p[i++] = Vpid; // PCR pid lo
+     p[i++] = 0xF0; // dummy (4), program info length hi (4)
+     p[i++] = 0x00; // program info length lo
+
+     if (Vpid)
+        i += MakeStream(buf + i, Channel->Vtype(), Vpid);
+     for (int n = 0; Channel->Apid(n); n++) {
+         i += MakeStream(buf + i, 0x04, Channel->Apid(n));
+         const char *Alang = Channel->Alang(n);
+         i += MakeLanguageDescriptor(buf + i, Alang);
+         if (Alang[3] == '+')
+            i += MakeLanguageDescriptor(buf + i, Alang + 3);
+         }
+     for (int n = 0; Channel->Dpid(n); n++) {
+         i += MakeStream(buf + i, 0x06, Channel->Dpid(n));
+         i += MakeAC3Descriptor(buf + i);
+         i += MakeLanguageDescriptor(buf + i, Channel->Dlang(n));
+         }
+     for (int n = 0; Channel->Spid(n); n++) {
+         i += MakeStream(buf + i, 0x06, Channel->Spid(n));
+         i += MakeSubtitlingDescriptor(buf + i, Channel->Slang(n));
+         }
+
+     int sl = i - SectionLength - 2 + 4; // -2 = SectionLength storage, +4 = length of CRC
+     buf[SectionLength] |= (sl >> 8) & 0x0F;
+     buf[SectionLength + 1] = sl;
+     MakeCRC(buf + i, buf, i);
+     // split the PMT section into several TS packets:
+     uchar *q = buf;
+     while (i > 0) {
+           uchar *p = pmt[numPmtPackets++];
+           int j = 0;
+           p[j++] = 0x47; // TS indicator
+           p[j++] = 0x40 | (P_PNR >> 8); // flags (3), pid hi (5)
+           p[j++] = P_PNR & 0xFF; // pid lo
+           p[j++] = 0x10; // flags (4), continuity counter (4)
+           int l = TS_SIZE - j;
+           memcpy(p + j, q, l);
+           q += l;
+           i -= l;
+           }
+     IncVersion(pmtVersion);
+     }
+  else
+     esyslog("ERROR: can't find channel %s", *ChannelID.ToString());
+}
+
+uchar *cPatPmtGenerator::GetPat(void)
+{
+  IncCounter(patCounter, pat);
+  return pat;
+}
+
+uchar *cPatPmtGenerator::GetPmt(int &Index)
+{
+  if (Index < numPmtPackets) {
+     IncCounter(patCounter, pmt[Index]);
+     return pmt[Index++];
+     }
+  return NULL;
+}
+
+// --- cPatPmtParser ---------------------------------------------------------
+
+cPatPmtParser::cPatPmtParser(void)
+{
+  pmtSize = 0;
+  pmtPid = -1;
+  vpid = vtype = 0;
+}
+
+void cPatPmtParser::ParsePat(const uchar *Data, int Length)
+{
+  // The PAT is always assumed to fit into a single TS packet
+  SI::PAT Pat(Data, false);
+  if (Pat.CheckCRCAndParse()) {
+     dbgpatpmt("PAT: TSid = %d, c/n = %d, v = %d, s = %d, ls = %d\n", Pat.getTransportStreamId(), Pat.getCurrentNextIndicator(), Pat.getVersionNumber(), Pat.getSectionNumber(), Pat.getLastSectionNumber());
+     SI::PAT::Association assoc;
+     for (SI::Loop::Iterator it; Pat.associationLoop.getNext(assoc, it); ) {
+         dbgpatpmt("     isNITPid = %d\n", assoc.isNITPid());
+         if (!assoc.isNITPid()) {
+            pmtPid = assoc.getPid();
+            dbgpatpmt("     service id = %d, pid = %d\n", assoc.getServiceId(), assoc.getPid());
+            }
+         }
+     }
+  else
+     esyslog("ERROR: can't parse PAT");
+}
+
+void cPatPmtParser::ParsePmt(const uchar *Data, int Length)
+{
+  // The PMT may extend over several TS packets, so we need to assemble them
+  if (pmtSize == 0) {
+     // this is the first packet
+     if (SectionLength(Data, Length) > Length) {
+        if (Length <= int(sizeof(pmt))) {
+           memcpy(pmt, Data, Length);
+           pmtSize = Length;
+           }
+        else
+           esyslog("ERROR: PMT packet length too big (%d byte)!", Length);
+        return;
+        }
+     // the packet contains the entire PMT section, so we run into the actual parsing
+     }
+  else {
+     // this is a following packet, so we add it to the pmt storage
+     if (Length <= int(sizeof(pmt)) - pmtSize) {
+        memcpy(pmt + pmtSize, Data, Length);
+        pmtSize += Length;
+        }
+     else {
+        esyslog("ERROR: PMT section length too big (%d byte)!", pmtSize + Length);
+        pmtSize = 0;
+        }
+     if (SectionLength(pmt, pmtSize) > pmtSize)
+        return; // more packets to come
+     // the PMT section is now complete, so we run into the actual parsing
+     Data = pmt;
+     }
+  SI::PMT Pmt(Data, false);
+  if (Pmt.CheckCRCAndParse()) {
+     dbgpatpmt("PMT: sid = %d, c/n = %d, v = %d, s = %d, ls = %d\n", Pmt.getServiceId(), Pmt.getCurrentNextIndicator(), Pmt.getVersionNumber(), Pmt.getSectionNumber(), Pmt.getLastSectionNumber());
+     dbgpatpmt("     pcr = %d\n", Pmt.getPCRPid());
+     cDevice::PrimaryDevice()->ClrAvailableTracks(false, true);
+     int NumApids = 0;
+     int NumDpids = 0;
+     int NumSpids = 0;
+     SI::PMT::Stream stream;
+     for (SI::Loop::Iterator it; Pmt.streamLoop.getNext(stream, it); ) {
+         dbgpatpmt("     stream type = %02X, pid = %d", stream.getStreamType(), stream.getPid());
+         switch (stream.getStreamType()) {
+           case 0x02: // STREAMTYPE_13818_VIDEO
+           case 0x1B: // MPEG4
+                      vpid = stream.getPid();
+                      vtype = stream.getStreamType();
+                      break;
+           case 0x04: // STREAMTYPE_13818_AUDIO
+                      {
+                      if (NumApids < MAXAPIDS) {
+                         char ALangs[MAXLANGCODE2] = "";
+                         SI::Descriptor *d;
+                         for (SI::Loop::Iterator it; (d = stream.streamDescriptors.getNext(it)); ) {
+                             switch (d->getDescriptorTag()) {
+                               case SI::ISO639LanguageDescriptorTag: {
+                                    SI::ISO639LanguageDescriptor *ld = (SI::ISO639LanguageDescriptor *)d;
+                                    SI::ISO639LanguageDescriptor::Language l;
+                                    char *s = ALangs;
+                                    int n = 0;
+                                    for (SI::Loop::Iterator it; ld->languageLoop.getNext(l, it); ) {
+                                        if (*ld->languageCode != '-') { // some use "---" to indicate "none"
+                                           dbgpatpmt(" '%s'", l.languageCode);
+                                           if (n > 0)
+                                              *s++ = '+';
+                                           strn0cpy(s, I18nNormalizeLanguageCode(l.languageCode), MAXLANGCODE1);
+                                           s += strlen(s);
+                                           if (n++ > 1)
+                                              break;
+                                           }
+                                        }
+                                    }
+                                    break;
+                               default: ;
+                               }
+                             delete d;
+                             }
+                         cDevice::PrimaryDevice()->SetAvailableTrack(ttAudio, NumApids, stream.getPid(), ALangs);
+                         NumApids++;
+                         }
+                      }
+                      break;
+           case 0x06: // STREAMTYPE_13818_PES_PRIVATE
+                      {
+                      int dpid = 0;
+                      char lang[MAXLANGCODE1] = "";
+                      SI::Descriptor *d;
+                      for (SI::Loop::Iterator it; (d = stream.streamDescriptors.getNext(it)); ) {
+                          switch (d->getDescriptorTag()) {
+                            case SI::AC3DescriptorTag:
+                                 dbgpatpmt(" AC3");
+                                 dpid = stream.getPid();
+                                 break;
+                            case SI::SubtitlingDescriptorTag:
+                                 dbgpatpmt(" subtitling");
+                                 if (NumSpids < MAXSPIDS) {
+                                    SI::SubtitlingDescriptor *sd = (SI::SubtitlingDescriptor *)d;
+                                    SI::SubtitlingDescriptor::Subtitling sub;
+                                    char SLangs[MAXLANGCODE2] = "";
+                                    char *s = SLangs;
+                                    int n = 0;
+                                    for (SI::Loop::Iterator it; sd->subtitlingLoop.getNext(sub, it); ) {
+                                        if (sub.languageCode[0]) {
+                                           dbgpatpmt(" '%s'", sub.languageCode);
+                                           if (n > 0)
+                                              *s++ = '+';
+                                           strn0cpy(s, I18nNormalizeLanguageCode(sub.languageCode), MAXLANGCODE1);
+                                           s += strlen(s);
+                                           if (n++ > 1)
+                                              break;
+                                           }
+                                        }
+                                    cDevice::PrimaryDevice()->SetAvailableTrack(ttSubtitle, NumSpids, stream.getPid(), SLangs);
+                                    NumSpids++;
+                                    }
+                                 break;
+                            case SI::ISO639LanguageDescriptorTag: {
+                                 SI::ISO639LanguageDescriptor *ld = (SI::ISO639LanguageDescriptor *)d;
+                                 dbgpatpmt(" '%s'", ld->languageCode);
+                                 strn0cpy(lang, I18nNormalizeLanguageCode(ld->languageCode), MAXLANGCODE1);
+                                 }
+                                 break;
+                            default: ;
+                            }
+                          delete d;
+                          }
+                      if (dpid) {
+                         if (NumDpids < MAXDPIDS) {
+                            cDevice::PrimaryDevice()->SetAvailableTrack(ttDolby, NumDpids, dpid, lang);
+                            NumDpids++;
+                            }
+                         }
+                      }
+                      break;
+           }
+         dbgpatpmt("\n");
+         cDevice::PrimaryDevice()->EnsureAudioTrack(true);
+         cDevice::PrimaryDevice()->EnsureSubtitleTrack();
+         }
+     }
+  else
+     esyslog("ERROR: can't parse PMT");
+  pmtSize = 0;
+}
+
+// --- cTsToPes --------------------------------------------------------------
+
+cTsToPes::cTsToPes(void)
+{
+  data = NULL;
+  size = length = 0;
+  synced = false;
+}
+
+cTsToPes::~cTsToPes()
+{
+  free(data);
+}
+
+void cTsToPes::PutTs(const uchar *Data, int Length)
+{
+  if (TsPayloadStart(Data))
+     Reset();
+  else if (!size)
+     return; // skip everything before the first payload start
+  Length = TsGetPayload(&Data);
+  if (length + Length > size) {
+     size = max(KILOBYTE(2), length + Length);
+     data = (uchar *)realloc(data, size);
+     }
+  memcpy(data + length, Data, Length);
+  length += Length;
+}
+
+const uchar *cTsToPes::GetPes(int &Length)
+{
+  if (PesLongEnough(length)) {
+     Length = PesLength(data);
+     if (Length <= length) {
+        Length = length; // in case the PES packet has no explicit length, as is the case for video PES
+        return data;
+        }
+     }
+  return NULL;
+}
+
+void cTsToPes::Reset(void)
+{
+  length = 0;
+}
+
+// --- Some helper functions for debugging -----------------------------------
+
+void BlockDump(const char *Name, const u_char *Data, int Length)
+{
+  printf("--- %s\n", Name);
+  for (int i = 0; i < Length; i++) {
+      if (i && (i % 16) == 0)
+         printf("\n");
+      printf(" %02X", Data[i]);
+      }
+  printf("\n");
+}
+
+void TsDump(const char *Name, const u_char *Data, int Length)
+{
+  printf("%s: %04X", Name, Length);
+  int n = min(Length, 20);
+  for (int i = 0; i < n; i++)
+      printf(" %02X", Data[i]);
+  if (n < Length) {
+     printf(" ...");
+     n = max(n, Length - 10);
+     for (n = max(n, Length - 10); n < Length; n++)
+         printf(" %02X", Data[n]);
+     }
+  printf("\n");
+}
+
+void PesDump(const char *Name, const u_char *Data, int Length)
+{
+  TsDump(Name, Data, Length);
+}
diff -ruN vdr-1.7.0/remux.h vdr-1.7.1/remux.h
--- vdr-1.7.0/remux.h	2007-09-02 12:19:06.000000000 +0200
+++ vdr-1.7.1/remux.h	2008-09-06 16:48:28.000000000 +0200
@@ -4,14 +4,13 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: remux.h 2.0 2007/09/02 10:19:06 kls Exp $
+ * $Id: remux.h 2.2 2008/09/06 14:48:28 kls Exp $
  */
 
 #ifndef __REMUX_H
 #define __REMUX_H
 
-#include <time.h> //XXX FIXME: DVB/linux/dvb/dmx.h should include <time.h> itself!!!
-#include <linux/dvb/dmx.h>
+#include "channels.h"
 #include "ringbuffer.h"
 #include "tools.h"
 
@@ -81,4 +80,192 @@
   static int ScanVideoPacket(const uchar *Data, int Count, int Offset, uchar &PictureType);
   };
 
+// Some TS handling tools.
+// The following functions all take a pointer to one complete TS packet.
+
+#define TS_SYNC_BYTE          0x47
+#define TS_SIZE               188
+#define TS_ADAPT_FIELD_EXISTS 0x20
+#define TS_PAYLOAD_EXISTS     0x10
+#define TS_CONT_CNT_MASK      0x0F
+#define TS_PAYLOAD_START      0x40
+#define TS_ERROR              0x80
+#define TS_PID_MASK_HI        0x1F
+
+inline int TsHasPayload(const uchar *p)
+{
+  return p[3] & TS_PAYLOAD_EXISTS;
+}
+
+inline int TsPayloadStart(const uchar *p)
+{
+  return p[1] & TS_PAYLOAD_START;
+}
+
+inline int TsError(const uchar *p)
+{
+  return p[1] & TS_ERROR;
+}
+
+inline int TsPid(const uchar *p)
+{
+  return (p[1] & TS_PID_MASK_HI) * 256 + p[2];
+}
+
+inline int TsPayloadOffset(const uchar *p)
+{
+  return (p[3] & TS_ADAPT_FIELD_EXISTS) ? p[4] + 5 : 4;
+}
+
+inline int TsGetPayload(const uchar **p)
+{
+  int o = TsPayloadOffset(*p);
+  *p += o;
+  return TS_SIZE - o;
+}
+
+inline int TsContinuityCounter(const uchar *p)
+{
+  return p[3] & TS_CONT_CNT_MASK;
+}
+
+// Some PES handling tools:
+// The following functions that take a pointer to PES data all assume that
+// there is enough data so that PesLongEnough() returns true.
+
+inline bool PesLongEnough(int Length)
+{
+  return Length >= 6;
+}
+
+inline int PesLength(const uchar *p)
+{
+  return 6 + p[4] * 256 + p[5];
+}
+
+inline int PesPayloadOffset(const uchar *p)
+{
+  return 9 + p[8];
+}
+
+inline int64_t PesGetPts(const uchar *p)
+{
+  if ((p[7] & 0x80) && p[8] >= 5) {
+     return ((((int64_t)p[ 9]) & 0x0E) << 29) |
+            (( (int64_t)p[10])         << 22) |
+            ((((int64_t)p[11]) & 0xFE) << 14) |
+            (( (int64_t)p[12])         <<  7) |
+            ((((int64_t)p[13]) & 0xFE) >>  1);
+     }
+  return 0;
+}
+
+// PAT/PMT Generator:
+
+#define MAX_SECTION_SIZE 4096 // maximum size of an SI section
+#define MAX_PMT_TS  (MAX_SECTION_SIZE / TS_SIZE + 1)
+
+class cPatPmtGenerator {
+private:
+  uchar pat[TS_SIZE]; // the PAT always fits into a single TS packet
+  uchar pmt[MAX_PMT_TS][TS_SIZE]; // the PMT may well extend over several TS packets
+  int numPmtPackets;
+  int patCounter;
+  int pmtCounter;
+  int patVersion;
+  int pmtVersion;
+  uchar *esInfoLength;
+  void IncCounter(int &Counter, uchar *TsPacket);
+  void IncVersion(int &Version);
+  void IncEsInfoLength(int Length);
+protected:
+  int MakeStream(uchar *Target, uchar Type, int Pid);
+  int MakeAC3Descriptor(uchar *Target);
+  int MakeSubtitlingDescriptor(uchar *Target, const char *Language);
+  int MakeLanguageDescriptor(uchar *Target, const char *Language);
+  int MakeCRC(uchar *Target, const uchar *Data, int Length);
+public:
+  cPatPmtGenerator(void);
+  void GeneratePat(void);
+       ///< Generates a PAT section for later use with GetPat().
+       ///< This function is called by default from the constructor.
+  void GeneratePmt(tChannelID ChannelID);
+       ///< Generates a PMT section for the given ChannelId, for later use
+       ///< with GetPmt().
+  uchar *GetPat(void);
+       ///< Returns a pointer to the PAT section, which consist of exactly
+       ///< one TS packet.
+  uchar *GetPmt(int &Index);
+       ///< Returns a pointer to the Index'th TS packet of the PMT section.
+       ///< Index must be initialized to 0 and will be incremented by each
+       ///< call to GetPmt(). Returns NULL is all packets of the PMT section
+       ///< have been fetched..
+  };
+
+// PAT/PMT Parser:
+
+class cPatPmtParser {
+private:
+  uchar pmt[MAX_SECTION_SIZE];
+  int pmtSize;
+  int pmtPid;
+  int vpid;
+  int vtype;
+protected:
+  int SectionLength(const uchar *Data, int Length) { return (Length >= 3) ? ((int(Data[1]) & 0x0F) << 8)| Data[2] : 0; }
+public:
+  cPatPmtParser(void);
+  void ParsePat(const uchar *Data, int Length);
+       ///< Parses the given PAT Data, which is the payload of a single TS packet
+       ///< from the PAT stream. The PAT may consist only of a single TS packet.
+  void ParsePmt(const uchar *Data, int Length);
+       ///< Parses the given PMT Data, which is the payload of a single TS packet
+       ///< from the PMT stream. The PMT may consist of several TS packets, which
+       ///< are delivered to the parser through several subsequent calls to
+       ///< ParsePmt(). The whole PMT data will be processed once the last packet
+       ///< has been received.
+  int PmtPid(void) { return pmtPid; }
+       ///< Returns the PMT pid as defined by the current PAT.
+       ///< If no PAT has been received yet, -1 will be returned.
+  int Vpid(void) { return vpid; }
+       ///< Returns the video pid as defined by the current PMT.
+  int Vtype(void) { return vtype; }
+  };
+
+// TS to PES converter:
+// Puts together the payload of several TS packets that form one PES
+// packet.
+
+class cTsToPes {
+private:
+  uchar *data;
+  int size;
+  int length;
+  bool synced;
+public:
+  cTsToPes(void);
+  ~cTsToPes();
+  void PutTs(const uchar *Data, int Length);
+       ///< Puts the payload data of the single TS packet at Data into the converter.
+       ///< Length is always 188.
+       ///< If the given TS packet starts a new PES payload packet, the converter
+       ///< will be automatically reset. Any packets before the first one that starts
+       ///< a new PES payload packet will be ignored.
+  const uchar *GetPes(int &Length);
+       ///< Gets a pointer to the complete PES packet, or NULL if the packet
+       ///< is not complete yet. If the packet is complete, Length will contain
+       ///< the total packet length. The returned pointer is only valid until
+       ///< the next call to PutTs() or Reset(), or until this object is destroyed.
+  void Reset(void);
+       ///< Resets the converter. This needs to be called after a PES packet has
+       ///< been fetched by a call to GetPes(), and before the next call to
+       ///< PutTs().
+  };
+
+// Some helper functions for debugging:
+
+void BlockDump(const char *Name, const u_char *Data, int Length);
+void TsDump(const char *Name, const u_char *Data, int Length);
+void PesDump(const char *Name, const u_char *Data, int Length);
+
 #endif // __REMUX_H
diff -ruN vdr-1.7.0/sources.conf vdr-1.7.1/sources.conf
--- vdr-1.7.0/sources.conf	2007-02-17 17:15:13.000000000 +0100
+++ vdr-1.7.1/sources.conf	2008-08-16 12:02:27.000000000 +0200
@@ -19,29 +19,34 @@
 
 # Europe
 
-S5E     Sirius 2/3
+S3E     Telecom 2C
+S4E     Eurobird 4
+S5E     Sirius 4
 S7E     Eutelsat W3A
+S9E     Eurobird 9
 S10E    Eutelsat W1
-S13E    Hotbird 1-3/6/7A
+S13E    Hotbird 6/7A/8
 S16E    Eutelsat W2
-S19.2E  Astra 1B/C/E/F/G/H/2C
+S19.2E  Astra F/G/H/KR/L
 S21.0E  Afristar 1
 S21.6E  Eutelsat W6
-S23.5E  Astra 1D 3A
-S26E    Arabsat 2D/2C/3A
+S23.5E  Astra 1E/3A
+S25.5E  Eurobird 2
+S26E    Badr 3/4/6
 S28.2E  Astra 2D/A/B
-S28.5E  Eurobird 1 & Astra 2A/B/D
+S28.5E  Eurobird 1 & Astra 2A/B/C/D
 S30.5E  Arabsat 2B
+S31.5E  Astra 1D/5A
 S33E    Eurobird 3 & Intelsat 802
 S36E    Eutelsat W4 & Sesat
 S38E    Paksat 1
 S39E    Hellas Sat 2
 S40E    Express AM1
-S42E    Turksat 1C/2A
+S42E    Turksat 2A/3A
 S45E    Intelsat 12
 S49E    Yamal 202
 S53E    Express AM 22
-S55E    Insat 3E & Intelsat 702
+S55E    Insat 3E 
 S56E    Bonum 1
 S57E    NSS 703
 S60E    Intelsat 904
@@ -54,10 +59,10 @@
 
 # Asia
 
-S74E    Insat 3C & Edusat
-S75E    LMI 1
+S74E    Insat 3C/4CR & Edusat
+S75E    ABS 1
 S76.5E  Telstar 10
-S78.5E  Thaicom 2/3
+S78.5E  Thaicom 2/5
 S80E    Express AM2
 S83E    Insat 2E/3B/4A
 S85.2E  Intelsat 709
@@ -65,14 +70,17 @@
 S88E    ST 1
 S90E    Yamal 201
 S91.5E  Measat 1
-S93.5E  Insat 3A
+S92.2E  Chinasat 9
+S93.5E  Insat 3A/4B
 S95E    NSS 6
-S96.5E  Express AM 11
+S96.5E  Express AM 33
+S98.5E  Protostar 1
 S100.5E Asiasat 2
 S103E   Express A2
+S105E   Asiastar
 S105.5E Asiasat 3S
 S107.7E Cakrawarta 1
-S108E   Telkom 1 & AAP 1
+S108E   Telkom 1 & NSS 11
 S110E   N-Sat 110 & BSAT 1A/2A
 S110.5E Sinosat 1
 S113E   Palapa C2 & Koreasat 2
@@ -81,38 +89,38 @@
 S120E   Thaicom 1A
 S122.2E Asiasat 4
 S124E   JCSAT 4a
+S125E   Sinosat 3
 S128E   JCSAT 3
-S132E   N-Star A
+S132E   Vinasat 1 & JCSAT5a
 S134E   Apstar 6
-S136E   N-Star B
 S138E   Telstar 18
 S140E   Express AM 3
 S144E   Superbird C
 S146E   Agila 2
 S148E   Measat 2
 S150E   JCSAT R
-S152E   Optus B3
+S152E   Optus D2
 S154E   JCSAT 2A
 S156E   Optus C1
 S158E   Superbird A
-S160E   Optus B1
+S160E   Optus D1
 S162E   Superbird B2
-S164E   Optus A3
+S164E   Optus B3
 S166E   Intelsat 8
 S169E   Intelsat 2
-S172E   AMC 23
+S172E   GE 23
 S180E   Intelsat 701
 S177W   NSS 5
 
 # Atlantic
 
-S1W     Thor 2/3 & Intelsat 10-02
-S4W     Amos 1/2
+S1W     Thor 3/5 & Intelsat 10-02
+S4W     Amos 1/2/3
 S5W     Atlantic Bird 3
-S7W     Nilesat 101 & 102
+S7W     Nilesat 101/102 & Atlantic Bird 4
 S8W     Telecom 2D & Atlantic Bird 2
 S11W    Express A3
-S12.5W  Atlantic Bird 2
+S12.5W  Atlantic Bird 1
 S14W    Express A4
 S15W    Telstar 12
 S18W    Intelsat 901
@@ -123,9 +131,9 @@
 S30W    Hispasat 1C/1D
 S31.5W  Intelsat 801
 S34.5W  Intelsat 903
-S37.5W  Telstar 11 & AMC 12
+S37.5W  NSS 10
 S40.5W  NSS 806
-S43W    Intelsat 3R/6B
+S43W    Intelsat 3R/11
 S45W    Intelsat 1R
 S50W    Intelsat 705
 S53W    Intelsat 707
@@ -137,47 +145,45 @@
 
 S61.5W  Echostar 3 & Rainbow 1
 S63W    Estrelo de Sul 1
-S65W    Brasilsat B2
-S70W    Brasilsat B1
+S65W    Star One C1
+S70W    Star One C2
 S72W    Nahuel 1 & AMC 6
-S72.5W  DirecTV 1
-S74W    SBS 6
-S77W    Echostar 4
+S72.5W  DirecTV 1R & Echostar 6
+S74W    Horizons 2
+S77W    Echostar 4 & Galaxy 4R
 S79W    AMC5
-S79.5W  Nimiq 3
 S82W    Nimiq 2
 S83W    AMC 9
-S84W    Brasilsat B3
-S85W    AMC 2
+S84W    Brasilsat B3/4
+S85W    AMC 16
 S85.1W  XM 3
 S87W    AMC3
 S89W    Galaxy 28
-S91W    Galaxy 11 & Nimiq 1
-S91.5W  DirecTV 2
-S92W    Brasilsat B4
+S91W    Galaxy 11/17 & Nimiq 1
+S92W    Brasilsat B2
 S93W    Galaxy 26
 S95W    Galaxy 3C
 S97W    Galaxy 25
-S99W    Galaxy 4R
-S99.2W  Spaceway 2
-S101W   DirecTV 1R/4S/8 & AMC4
+S99W    Galaxy 16
+S99.2W  Spaceway 2 & DirecTV 11
+S101W   DirecTV 4S/8 & AMC 2/4
 S103W   AMC1
-S105W   AMC15
+S105W   AMC15/18
 S107.3W Anik F1/F1R
-S110W   DirecTV 5 & Echostar 6/8/10
+S110W   DirecTV 5 & Echostar 8/10
 S111.1W Anik F2
-S113W   Solidaridad 2
-S119W   Echostar 7 & DirecTV 7S
+S113W   SatMex 6
+S116.8W SatMex 5
+S119W   Anik F3 & Echostar 7 & DirecTV 7S
 S121W   Echostar 9 & Galaxy 23
-S123W   Galaxy 10R
+S123W   Galaxy 18
 S125W   Galaxy 14
 S127W   Galaxy 13/Horizons 1
 S129W   Echostar 5 & Galaxy 27
 S131W   AMC 11
-S133W   Galaxy15/1R
+S133W   Galaxy15
 S135W   AMC 10
 S137W   AMC 7
-S138.5W Echostar 10
 S139W   AMC 8
 S148W   Echostar 1/2
 
diff -ruN vdr-1.7.0/svdrp.c vdr-1.7.1/svdrp.c
--- vdr-1.7.0/svdrp.c	2008-02-17 14:36:01.000000000 +0100
+++ vdr-1.7.1/svdrp.c	2008-05-02 16:15:38.000000000 +0200
@@ -10,7 +10,7 @@
  * and interact with the Video Disk Recorder - or write a full featured
  * graphical interface that sits on top of an SVDRP connection.
  *
- * $Id: svdrp.c 2.0 2008/02/17 13:36:01 kls Exp $
+ * $Id: svdrp.c 2.1 2008/05/02 14:15:38 kls Exp $
  */
 
 #include "svdrp.h"
@@ -1606,7 +1606,7 @@
         char buffer[BUFSIZ];
         gethostname(buffer, sizeof(buffer));
         time_t now = time(NULL);
-        Reply(220, "%s SVDRP VideoDiskRecorder %s; %s", buffer, VDRVERSION, *TimeToString(now));
+        Reply(220, "%s SVDRP VideoDiskRecorder %s; %s; %s", buffer, VDRVERSION, *TimeToString(now), cCharSetConv::SystemCharacterTable() ? cCharSetConv::SystemCharacterTable() : "UTF-8");
         }
      if (NewConnection)
         lastActivity = time(NULL);
diff -ruN vdr-1.7.0/thread.c vdr-1.7.1/thread.c
--- vdr-1.7.0/thread.c	2008-04-13 13:53:56.000000000 +0200
+++ vdr-1.7.1/thread.c	2008-09-06 11:39:43.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: thread.c 2.1 2008/04/13 11:53:56 kls Exp $
+ * $Id: thread.c 2.2 2008/09/06 09:39:43 kls Exp $
  */
 
 #include "thread.h"
@@ -25,11 +25,12 @@
 {
   struct timeval now;
   if (gettimeofday(&now, NULL) == 0) {           // get current time
-     now.tv_usec += MillisecondsFromNow * 1000;  // add the timeout
-     while (now.tv_usec >= 1000000) {            // take care of an overflow
-           now.tv_sec++;
-           now.tv_usec -= 1000000;
-           }
+     now.tv_sec  += MillisecondsFromNow / 1000;  // add full seconds
+     now.tv_usec += (MillisecondsFromNow % 1000) * 1000;  // add microseconds
+     if (now.tv_usec >= 1000000) {               // take care of an overflow
+        now.tv_sec++;
+        now.tv_usec -= 1000000;
+        }
      Abstime->tv_sec = now.tv_sec;          // seconds
      Abstime->tv_nsec = now.tv_usec * 1000; // nano seconds
      return true;
